/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.privacy;

import de.tudarmstadt.maki.simonstrator.api.Host;
import de.tudarmstadt.maki.simonstrator.api.component.HostComponent;
import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;

public class PrivacyComponent implements HostComponent {
	private Host _host;

	private PrivacyLevel _privacy = PrivacyLevel.NO_PRIVACY;

	public PrivacyComponent(Host pHost) {
		_host = pHost;
	}

	public void setPrivacy(PrivacyLevel pLevel) {
		_privacy = pLevel;
	}

	@Override
	public void initialize() {

	}

	@Override
	public void shutdown() {

	}

	@Override
	public Host getHost() {
		return _host;
	}

	public Location obscureLocation(Location pLocation) {
		Location location = pLocation.clone();
		location.setAccuracy(_privacy.getImprecisionAreaRadius());
		return location;
	}

	public PrivacyLevel getPrivacyLevel() {
		return _privacy;
	}

	public void setPrivacyLevel(PrivacyLevel pPrivacy) {
		_privacy = pPrivacy;
	}
}
