/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.sensor.environment.costs;

public class PropertyImpactEstimatorFactory {
	private static PropertyImpactEstimator _costEstimator = null;

	public static void registerPropertyBenefitEstimator(PropertyImpactEstimator pBenefitEstimator) {
		synchronized (PropertyImpactEstimatorFactory.class) {
			_costEstimator = pBenefitEstimator;
		}
	}

	public static PropertyImpactEstimator getPropertyBenefitEstimator() {
		synchronized (PropertyImpactEstimatorFactory.class) {
			if (_costEstimator == null) {
				System.err.println("No property impact estimator set! Falling back to "
						+ DefaultVehicularPropertyImpactEstimator.class.getSimpleName());
				_costEstimator = new DefaultVehicularPropertyImpactEstimator();
			}
		}
		return _costEstimator;
	}
}
