/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


package de.tudarmstadt.maki.simonstrator.api.component.sensor.environment.data.properties.vectoral;

import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkEdge;

/**
 * @author Tobias Meuser (tobias.meuser@kom.tu-darmstadt.de)
 * @version 1.0 at 13.04.2018
 *
 */
public abstract class NumericVectoralProperty extends VectoralProperty {

	public NumericVectoralProperty(Location pLocation, RoadNetworkEdge pEdge, double[] values) {
		super(pLocation, pEdge, values);
	}

	public NumericVectoralProperty(Location pLocation, RoadNetworkEdge pEdge, int pValueAmount) {
		super(pLocation, pEdge, pValueAmount);
	}

	@Override
	public abstract NumericVectoralProperty clone();

	@Override
	public abstract Double getValueAtIndex(int pIndex);

	@Override
	public Double getMostProbableValue() {
		return (Double) super.getMostProbableValue();
	}

	public Double getExpectation() {
		double sum = 0;

		double[] probs = getValueProbabilities();
		for (int i = 0; i < probs.length; i++) {
			sum += getValueAtIndex(i) * probs[i];
		}

		return sum;
	}

}
